
/*
 *  Configuration table declaration information
 */

#include	"config.h"
#include	"sys/param.h"
#include	"sys/types.h"
#include	"sys/sysmacros.h"
#include	"sys/signal.h"
#include	"sys/fs/s5dir.h"
#include	"sys/user.h"
#include	"sys/phinf.h"
#include	"sys/icb.h"
#include	"sys/stream.h"
#include	"sys/conf.h"
#include	"sys/space.h"
#include	"sys/errno.h"

extern nodev(), nulldev();
extern conopen(), conclose(), conread(), conwrite(), conioctl();
extern clnopen();
extern struct streamtab clninfo;
extern spopen(), spclose();
extern struct streamtab spinfo;
extern logopen(), logclose();
extern struct streamtab loginfo;
extern sarioctl();
extern sxtopen(), sxtclose(), sxtread(), sxtwrite(), sxtioctl();
extern macopen(), macclose(), macread(), macwrite(), macioctl();
extern gclp_open(), gclp_close(), gclp_write(), gclp_ioctl();
extern gctty_open(), gctty_close(), gctty_read(), gctty_write(), gctty_ioctl();
extern ntc2open(), ntc2close(), ntc2read(), ntc2write(), ntc2ioctl();
extern ntcopen(), ntcclose(), ntcread(), ntcwrite(), ntcioctl();
extern ntopen(), ntclose(), ntread(), ntwrite(), ntioctl();
extern rdkopen(), rdkclose(), rdkstrategy(), rdkprint();
extern mtopen(), mtclose(), mtread(), mtwrite(), mtioctl();
extern sdk3open(), sdk3close(), sdk3read(), sdk3write(), sdk3ioctl(), sdk3strategy(), sdk3print();
extern sdk2open(), sdk2close(), sdk2read(), sdk2write(), sdk2ioctl(), sdk2strategy(), sdk2print();
extern sdk1open(), sdk1close(), sdk1read(), sdk1write(), sdk1ioctl(), sdk1strategy(), sdk1print();
extern sdk0open(), sdk0close(), sdk0read(), sdk0write(), sdk0ioctl(), sdk0strategy(), sdk0print();
extern dkopen(), dkclose(), dkread(), dkwrite(), dkstrategy(), dkprint();
extern erropen(), errclose(), errread();
extern syopen(), syread(), sywrite(), syioctl();
extern icbopen(), icbclose(), icbread(), icbwrite(), icbioctl();
extern mmread(), mmwrite();

struct bdevsw bdevsw[] = {
/* 0*/	dkopen, dkclose, dkstrategy, dkprint,
/* 1*/	nodev,  nodev,  nodev,  0, 
/* 2*/	rdkopen, rdkclose, rdkstrategy, rdkprint,
/* 3*/	nodev,  nodev,  nodev,  0, 
/* 4*/	nodev,  nodev,  nodev,  0, 
/* 5*/	nodev,  nodev,  nodev,  0, 
/* 6*/	sdk0open, sdk0close, sdk0strategy, sdk0print,
/* 7*/	sdk1open, sdk1close, sdk1strategy, sdk1print,
/* 8*/	sdk2open, sdk2close, sdk2strategy, sdk2print,
/* 9*/	sdk3open, sdk3close, sdk3strategy, sdk3print,
};

#define	STR (struct streamtab *)0
#define	TTY (struct tty *)-1
#define	LGCTTY (struct tty *)L_GCTTY

struct cdevsw cdevsw[] = {
/* 0*/	conopen, conclose, conread, conwrite, conioctl, L_CON, STR,
/* 1*/	nulldev, nulldev, mmread, mmwrite, nodev,  TTY, STR,
/* 2*/	dkopen, dkclose, dkread, dkwrite, nodev,  TTY, STR,
/* 3*/	mtopen, mtclose, mtread, mtwrite, mtioctl, TTY, STR,
/* 4*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/* 5*/	icbopen, icbclose, icbread, icbwrite, icbioctl, TTY, STR,
/* 6*/	syopen, nulldev, syread, sywrite, syioctl, TTY, STR,
/* 7*/	sxtopen, sxtclose, sxtread, sxtwrite, sxtioctl, TTY, STR,
/* 8*/	gctty_open, gctty_close, gctty_read, gctty_write, gctty_ioctl, LGCTTY, STR,
/* 9*/	macopen, macclose, macread, macwrite, macioctl, TTY, STR,
/*10*/	erropen, errclose, errread, nodev,  nodev,  TTY, STR,
/*11*/	gclp_open, gclp_close, nodev,  gclp_write, gclp_ioctl, TTY, STR,
/*12*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*13*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*14*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*15*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*16*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*17*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*18*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*19*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*20*/	ntopen, ntclose, ntread, ntwrite, ntioctl, TTY, STR,
/*21*/	ntcopen, ntcclose, ntcread, ntcwrite, ntcioctl, TTY, STR,
/*22*/	nulldev, nulldev, nodev,  nodev,  sarioctl, TTY, STR,
/*23*/	ntc2open, ntc2close, ntc2read, ntc2write, ntc2ioctl, TTY, STR,
/*24*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*25*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*26*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*27*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*28*/	nulldev, nulldev, nodev,  nodev,  nodev,  TTY, STR,
/*29*/	logopen, logclose, nodev,  nodev,  nodev,  TTY, &loginfo,
/*30*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*31*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*32*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*33*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*34*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*35*/	spopen, spclose, nodev,  nodev,  nodev,  TTY, &spinfo,
/*36*/	clnopen, nulldev, nodev,  nodev,  nodev,  TTY, &clninfo,
/*37*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*38*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*39*/	nodev,  nodev,  nodev,  nodev,  nodev,  TTY,  STR,
/*40*/	sdk0open, sdk0close, sdk0read, sdk0write, sdk0ioctl, TTY, STR,
/*41*/	sdk1open, sdk1close, sdk1read, sdk1write, sdk1ioctl, TTY, STR,
/*42*/	sdk2open, sdk2close, sdk2read, sdk2write, sdk2ioctl, TTY, STR,
/*43*/	sdk3open, sdk3close, sdk3read, sdk3write, sdk3ioctl, TTY, STR,
};

/* Non-mapped buffer usage table */
int buftypes[] = {0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,};

int	bdevcnt = 10;
int	cdevcnt = 44;

dev_t	rootdev = makedev(0, 0);
dev_t	pipedev = makedev(0, 0);
dev_t	swapdev = makedev(0, 1);
daddr_t	swplo = 1;
int	nswap = 15872;


int	(*pwr_clr[])() = {	(int (*)())0
};

int	(*dev_init[])() = {	(int (*)())0
};
#ifdef	CON_0
extern ttopen(), ttclose(), ttread(), ttwrite(), ttioctl(), ttin(), ttout();
#endif
#ifdef	GCTTY_0
extern gtopen(), gtclose(), gtread(), gtwrite(), gtioctl(), gtin();
#endif
#ifdef	SXT_0
extern sxwrite(), sxin(), sxout();
#endif
#ifdef	GCTTM_0
extern gtopen(), gtclose(), gtread(), gtwrite(), gtioctl(), gtin();
#endif

struct linesw linesw[] = {
/* 0*/
#ifdef	CON_0
	ttopen, ttclose, ttread, ttwrite, ttioctl, ttin, ttout, nulldev, 
#else
	nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev,
#endif
/* 1*/
#ifdef	GCTTY_0
	gtopen, gtclose, gtread, gtwrite, gtioctl, gtin, nulldev, nulldev, 
#else
	nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev,
#endif
/* 2*/
#ifdef	SXT_0
	nulldev, nulldev, nulldev, sxwrite, nulldev, sxin, sxout, nulldev, 
#else
	nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev,
#endif
/* 3*/
#ifdef	GCTTM_0
	gtopen, gtclose, gtread, gtwrite, gtioctl, gtin, nulldev, nulldev, 
#else
	nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev, nulldev,
#endif
};
int	linecnt = 4;

#ifdef VT_VT100
extern  vt100input(), vt100output(), vt100ioctl();
#endif
#ifdef VT_HP45
extern  hp45input(), hp45output(), hp45ioctl();
#endif
struct termsw termsw[] = {
	nulldev, nulldev, nulldev, /* tty */
#ifdef VT_VT100
	vt100input, vt100output, vt100ioctl, /* VT100 */
#else
	nulldev, nulldev, nulldev,
#endif
#ifdef VT_HP45
	hp45input, hp45output, hp45ioctl, /* HP45 */
#else
	nulldev, nulldev, nulldev,
#endif
};
int	termcnt = sizeof(termsw) / sizeof(struct termsw);
