
#	@(#)local.mk	3.15

SYS	=	syst
NODE	=	syst
VER	=	`/usr/sys/month_day`
MACH	=	M68020
UMACH	=	M68020
NAME	=	$(NODE).$(VER)
IOMAKE	=	localio.mk
CFMAKE	=	localcf.mk
IOLIB	=	lib2
PREFIX	=	0
LD		=	/bin/$(PREFIX)ld
CC		=	/bin/$(PREFIX)cc
AS		=	/bin/$(PREFIX)as
C2		=	/lib/$(PREFIX)c2
CPP		=	/lib/$(PREFIX)cpp
CCOM		=	/lib/$(PREFIX)ccom

all:	$(NAME)


init:
#	cd localio; $(MAKE) -f $(IOMAKE) all LIBNAME=../$(IOLIB) PREFIX=$(PREFIX)
	cd cf; $(MAKE) -f $(CFMAKE) all SYS=$(SYS) NODE=$(NODE) VER=$(VER) PREFIX=$(PREFIX)

# WARNING, do not change order of link files

$(NAME): init
	@echo Linking...
# make an RFS only kernel
	@if [ "$(RFS)" = "TRUE" -a "$(NFS)" != "TRUE" ]; \
	then \
		echo "	$(LD) -o $(NAME) -e start% kernel.o \
			cf/conf.o cf/name.o librfs $(IOLIB) vuifile";\
		$(LD) -o $(NAME) -e start% kernel.o \
		          cf/conf.o cf/name.o librfs $(IOLIB) vuifile;\
	fi
# make an RFS/NFS kernel
	@if [ "$(RFS)" = "TRUE" -a "$(NFS)" = "TRUE" ]; \
	then \
		echo "	$(LD) -o $(NAME) -e start% kernel.o \
			cf/conf.o cf/name.o librfs libnfs $(IOLIB) vuifile";\
		$(LD) -o $(NAME) -e start% kernel.o \
		          cf/conf.o cf/name.o librfs libnfs $(IOLIB) vuifile;\
	fi
# make an NFS only kernel
	@if [ "$(RFS)" != "TRUE" -a "$(NFS)" = "TRUE" ]; \
	then \
		echo "	$(LD) -o $(NAME) -e start% kernel.o \
			cf/conf.o cf/name.o libnfs libs5 $(IOLIB) vuifile";\
		$(LD) -o $(NAME) -e start% kernel.o \
		          cf/conf.o cf/name.o libnfs libs5 $(IOLIB) vuifile;\
	fi
# make a "standard" kernel without RFS or NFS support
	@if [ "$(RFS)" != "TRUE" -a "$(NFS)" != "TRUE" ]; \
	then \
		echo "$(LD) -o $(NAME) -e start% kernel.o \
		          cf/conf.o cf/name.o libs5 $(IOLIB) vuifile"; \
		$(LD) -o $(NAME) -e start% kernel.o \
		          cf/conf.o cf/name.o libs5 $(IOLIB) vuifile; \
	fi
	
install: all
	@cp $(NAME) /
#	cp cf/config.h /usr/include/cf/config.h
	@chmod 444 $(NAME) /$(NAME)
#	@chmod 644 /usr/include/cf/config.h
	@chgrp sys $(NAME) /$(NAME)
#	@chgrp sys /usr/include/cf/config.h
	@chown root $(NAME) /$(NAME)
#	@chown root /usr/include/cf/config.h
	@echo $(NAME) is now installed in the root directory.
	@echo Review ./README for the remainder of the installation
	@echo procedure.

clean:
	cd cf; $(MAKE) -f $(CFMAKE) clean
#	cd localio; $(MAKE) -f $(IOMAKE) clean

clobber:
	cd cf; $(MAKE) -f $(CFMAKE) clobber
#	cd localio; $(MAKE) -f $(IOMAKE) clobber LIBNAME=../$(IOLIB)
